﻿Type=Class
Version=3
@EndOfDesignText@
'Class module
#Event: EnterPressed
#Event: FocusChanged (HasFocus As Boolean)
#Event: TextChanged (Old As String, New As String)

Sub Class_Globals
   Private mTarget As Object
   Private mEventName As String
   Private Edt As EditText
	Private mMaxLength As Int
End Sub

Public Sub Initialize (TargetModule As Object, EventName As String)
   mTarget = TargetModule
   mEventName = EventName
End Sub


Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	Edt.Initialize("Edt")
	Base.AddView(Edt, 0, 0, Base.Width, Base.Height)
End Sub

Public Sub setMaxLength(MaxLength As Int)
	mMaxLength = MaxLength
	If Edt.Text.Length = mMaxLength Then
		Edt.Text = Edt.Text.SubString2(0, mMaxLength)
	End If
End Sub
Public Sub getMaxLength As Int
	Return mMaxLength
End Sub


Public Sub GetEdt As EditText
	Return Edt
End Sub

Sub Edt_EnterPressed
	If SubExists(mTarget, mEventName & "_EnterPressed") Then
		CallSub(mTarget, mEventName & "_EnterPressed")
	End If
End Sub

Sub Edt_FocusChanged (HasFocus As Boolean)
	If SubExists(mTarget, mEventName & "_FocusChanged") Then
		CallSub2(mTarget, mEventName & "_FocusChanged", HasFocus)
	End If
End Sub

Sub Edt_TextChanged (Old As String, New As String)
	If New.Length > mMaxLength Then Edt.Text = Old
	If SubExists(mTarget, mEventName & "_TextChanged") Then
		CallSub3(mTarget, mEventName & "_TextChanged", Old, New)
	End If
End Sub

	
